#!/usr/bin/env python3
# @generated AUTOGENERATED file. Do not Change!

from dataclasses import dataclass
from datetime import datetime
from gql_client.runtime.datetime_utils import DATETIME_FIELD
from gql_client.runtime.graphql_client import GraphqlClient
from gql_client.runtime.reporter import FailedOperationException
from gql import gql
from gql.transport.exceptions import TransportQueryError
from functools import partial
from numbers import Number
from typing import Any, Callable, List, Mapping, Optional, Dict
from time import perf_counter
from dataclasses_json import DataClassJsonMixin

from ..fragment.location import LocationFragment, QUERY as LocationFragmentQuery
from ..fragment.page_info import PageInfoFragment, QUERY as PageInfoFragmentQuery

QUERY: List[str] = LocationFragmentQuery + PageInfoFragmentQuery + ["""
query GetLocationsQuery($after: Cursor, $first: Int) {
  locations(after: $after, first: $first) {
    edges {
      node {
        ...LocationFragment
      }
    }
    pageInfo {
      ...PageInfoFragment
    }
  }
}

"""]

class GetLocationsQuery(DataClassJsonMixin):
    @dataclass
    class GetLocationsQueryData(DataClassJsonMixin):
        @dataclass
        class LocationConnection(DataClassJsonMixin):
            @dataclass
            class LocationEdge(DataClassJsonMixin):
                @dataclass
                class Location(LocationFragment):
                    pass

                node: Optional[Location]

            @dataclass
            class PageInfo(PageInfoFragment):
                pass

            edges: List[LocationEdge]
            pageInfo: PageInfo

        locations: Optional[LocationConnection]

    @classmethod
    def execute(cls, client: GraphqlClient, after: Optional[str] = None, first: Optional[int] = None) -> Optional[GetLocationsQueryData.LocationConnection]:
        variables: Dict[str, Any] = {"after": after, "first": first}
        try:
            network_start = perf_counter()
            response_text = client.call(''.join(set(QUERY)), variables=variables)
            decode_start = perf_counter()
            res = cls.GetLocationsQueryData.from_dict(response_text)
            decode_time = perf_counter() - decode_start
            network_time = decode_start - network_start
            client.reporter.log_successful_operation("GetLocationsQuery", variables, network_time, decode_time)
            return res.locations
        except TransportQueryError as e:
            raise FailedOperationException(
                client.reporter,
                str(e.errors),
                "GetLocationsQuery",
                variables,
            )
